using System;

namespace Syntriax.Engine.Core.Exceptions;

public class AssignException : Exception
{
    public AssignException() : base("Assign operation has failed.") { }
    public AssignException(string? message) : base(message) { }

    public static AssignException From<T, T2>(T to, T2? value)
        => new($"Assign operation has failed on T: {to?.GetType().FullName ?? "\"null\""}, value: {value?.GetType().ToString() ?? "\"null\""}");
}
